#include <stdio.h>

#if defined __LCC__ && __LCC__ < 124

typedef struct {
	unsigned long long lo;
	unsigned long long hi;
} __uint128_t;
typedef struct {
	__uint128_t lo;
	__uint128_t hi;
} __uint256_t;
__uint256_t umul128(__uint128_t, __uint128_t);

__uint128_t str2ulll(const char *, char **, int);
__uint128_t absd128(__uint128_t, __uint128_t);

int main()
{
	__uint128_t a, b, c;
	char s[BUFSIZ], *p;
	fgets(s, sizeof(s), stdin);
        a = str2ulll(s, &p, 10);
        b = str2ulll(p, &p, 10);
	c = absd128(a, b);
	*p = '\0';
	do {
		unsigned long long n = c.lo;
		// H. Warren, Hacker's Delight, 10-14 Sample Magic Numbers
		__uint128_t d = {0xCCCCCCCCCCCCCCCD, 0xCCCCCCCCCCCCCCCC};
		__uint256_t e = umul128(c, d);
		c = e.hi;
		c.lo = c.hi << 61 | c.lo >> 3;
		c.hi >>= 3;
		*--p = n - 10 * c.lo + '0';
	} while (c.hi | c.lo);
	return puts(p);
}

#else

#ifdef __ARC64__
# include <unistd.h>
#endif

#ifdef __amd64__
# define ATTRIB	__attribute__((sysv_abi))
#else
# define ATTRIB
#endif

__uint128_t str2ulll(const char *, char **, int);
__uint128_t ATTRIB absd128(__int128_t, __int128_t);

int main()
{
	__int128_t a, b;
	__uint128_t c;
	char s[BUFSIZ], *p;

	setvbuf(stdin, NULL, _IONBF, 0);
	setvbuf(stdout, NULL, _IONBF, 0);
	fgets(s, sizeof(s), stdin);
        a = str2ulll(s, &p, 10);
        b = str2ulll(p, &p, 10);
	c = absd128(a, b);
	*p = '\0';
	do
		*--p = c % 10 + '0';
	while (c /= 10);
#ifdef __ARC64__
	_exit(puts(p));
#else
	return puts(p);
#endif
}

#endif
