#ifdef VERIFY

void downHeap(long long *a, int k, int n)
{
	long long tmp;
	int i;

	n--;
	for (tmp = a[k]; k <= n / 2; k = i) {
		i = 2 * k;
		if (i < n && a[i] < a[i+1])
			i++;
		if (tmp >= a[i])
			break;
		a[k] = a[i];
	}
	a[k] = tmp;
}

void heapSort(long long *a, int n)
{
	long long tmp;
	int i;

	for (i = n / 2; i >= 0; i--)
		downHeap(a, i, n);
	for (i = n - 1; i > 0; i--) {
		tmp = a[i];
		a[i] = a[0];
		a[0] = tmp;
		downHeap(a, 0, i);
	}
}
#else

#ifdef __amd64__
# define ATTRIB __attribute__((sysv_abi))
#else
# define ATTRIB
#endif

void ATTRIB heapSort(long long *, int);

#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#ifdef __ARC64__
# include <unistd.h>
#endif

ssize_t getrandom(void *, size_t, unsigned);

#define SIZE	35

int main()
{
	long long a[SIZE];
	int i;

#if defined __APPLE__ || defined __OpenBSD__
        arc4random_buf(a, sizeof(a));
#else
	getrandom(a, sizeof(a), 0);
#endif
	heapSort(a, SIZE);
	setvbuf(stdout, NULL, _IONBF, 0);
	for (i = 0; i < SIZE; i++)
		printf("%2d: %20lld\n", i, a[i]);
#ifdef __ARC64__
	_exit(0);
#else
	return 0;
#endif
}
